<?php
/**
 * Frontend index of media items by hashtag
 *
 * @package    BardCanvas
 * @subpackage gallery
 * @author     Alejandro Caballero - lava.caballero@gmail.com
 *
 * @var template $template
 * 
 * $_GET params:
 * @param tag
 */

include "../config.php";
include "../includes/bootstrap.inc";

use hng2_base\template;

$tag = trim(stripslashes($_GET["tag"]));
if( empty($tag) ) throw_fake_404();
if( preg_match("/[^a-z0-9]/i", $tag) ) throw_fake_501();

try { check_sql_injection($_GET); }
catch(\Exception $e) { throw_fake_501(); }

$template->set("page_tag",        "media_tag_index");
$template->set("showing_archive", true);
$template->set("current_tag",     $tag);

$template->page_contents_include = "by_tag.inc";
$template->set_page_title(replace_escaped_vars(
    $current_module->language->pages->by_tag->title, '{$tag}', $tag
));
$template->append("additional_body_attributes", " data-listing-type='archive'");
include "{$template->abspath}/main.php";
